Unit IIB2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTII12_p;

procedure IIB2R(var F :Array of Real; M :Integer; A :Real; H :Real;
                X :Real; var S :Real; var IERR :Integer);

implementation

procedure IIB2R(var F :Array of Real; M :Integer; A :Real; H :Real;
                X :Real; var S :Real; var IERR :Integer);
var
K :Integer;
R1,R2,R3,S1,S2,S3,T1,T2,T3,XM :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100;
begin
if ( H ) < 0
 then goto _20
 else if ( H ) > 0
       then goto _10
       else goto _20;
_10:
if ( (X - A)*(A + (M - 1)*H - X) ) < 0
 then goto _30
 else if ( (X - A)*(A + (M - 1)*H - X) ) > 0
       then goto _40
       else goto _40;
_20:
IERR  := 1;
goto _90;
_30:
IERR  := 2;
goto _90;
_40:
if ( X - A - H ) < 0
 then goto _60
 else if ( X - A - H ) > 0
       then goto _50
       else goto _80;
_50:
XM  := A + (M - 2)*H;
if ( X - XM ) < 0
 then goto _80
 else if ( X - XM ) > 0
       then goto _70
       else goto _80;
_60:
S  := F[1] + (F[1] - F[0])/H*(X - A - H);
goto _100;
_70:
S  := F[M-2] + (F[M-1] - F[M-2])/H*(X - XM);
goto _100;
_80:
K  := Trunc( (X - A + H/2)/H + 1 );
T1  := (A - H/2) + K*H;
T2  := T1 + H;
T3  := T2 + H;
R1  := IntPower((T1 - X)/H,2);
R2  := IntPower((T2 - X)/H,2);
R3  := IntPower((T3 - X)/H,2);
S1  := 0.5*R1;
S2  := 0.5*(R2 - 3*R1);
S3  := 0.5*(3*R1 - 3*R2 + R3);
S  := F[K-2]*S1 + F[K-1]*S2 + F[K+0]*S3;
goto _100;
_90:
if ( IERR  <>  0 ) 
 then UTII12(IERR,1);
_100:
end;

end.
